import {Component, Input} from '@angular/core';
import {Item} from "../../../project/game-model/inventory/Item";
import {ItemGroup} from "../../../project/game-model/inventory/ItemGroup";
import {GameModel} from "../../../project/game-model/GameModel";
import {MatDialog} from "@angular/material/dialog";
import {ItemgroupInheritorComponent} from "./itemgroup-inheritor/itemgroup-inheritor.component";

@Component({
  selector: 'app-item-editor',
  templateUrl: './item-editor.component.html',
  styleUrl: './item-editor.component.scss'
})
export class ItemEditorComponent {

  @Input() item: Item | undefined
  @Input() gameModel: GameModel | undefined;

  constructor(private dialog: MatDialog) {

  }

  onAddNewInheritedItemgroup() {
    const dialogRef = this.dialog.open(ItemgroupInheritorComponent, {
      data: this.gameModel!.itemgroupsAsList.filter(group => !this.item!.inheritedGroups.includes(group)),
      width: "400px"
    })

    dialogRef.afterClosed().subscribe(res => {
      if(res != undefined) {
        this.item!.inheritedGroups.push(res);
      }
    })
  }



}
