import {Component, Input, OnInit} from '@angular/core';
import {ItemGroup} from "../../../project/game-model/inventory/ItemGroup";
import {MatColumnDef, MatTable, MatTableDataSource} from "@angular/material/table";
import {ItemQuality} from "../../../project/game-model/inventory/ItemQuality";
import {ItemGroupCharacteristic} from "../../../project/game-model/inventory/ItemgroupCharacteristic";
import {Item} from "../../../project/game-model/inventory/Item";

@Component({
  selector: 'app-item-group-editor',
  templateUrl: './item-group-editor.component.html',
  styleUrl: './item-group-editor.component.scss'
})
export class ItemGroupEditorComponent implements OnInit{

  @Input() itemgroup: ItemGroup | undefined

  itemQualityDatasource: MatTableDataSource<ItemGroupCharacteristic> = new MatTableDataSource<ItemGroupCharacteristic>();
  displayedColumns: string[] = ["Characteristic", "Description", 'edit', 'delete']

  editedCharacteristic: ItemGroupCharacteristic | undefined;


  ngOnInit(): void {
    this.itemgroup!.itemGroupCharacteristics.push(new ItemGroupCharacteristic("Inventory", "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet."))
    this.itemQualityDatasource.data = this.itemgroup!.itemGroupCharacteristics;
  }

  deleteItemgroupCharacteristic(characteristic: ItemGroupCharacteristic) {
    this.itemgroup!.itemGroupCharacteristics = this.itemgroup!.itemGroupCharacteristics.filter(igc => igc.characteristicName !== characteristic.characteristicName);
    this.itemQualityDatasource.data = this.itemgroup!.itemGroupCharacteristics;
  }

  editItemgroupCharacteristic(characteristic: ItemGroupCharacteristic) {
    this.editedCharacteristic = characteristic;
  }

  finishEditing() {
    this.editedCharacteristic = undefined;
  }

  addItemgroupCharacteristic() {
    const itemgroupCharacteristic = new ItemGroupCharacteristic("", "");
    this.itemgroup!.itemGroupCharacteristics.push(itemgroupCharacteristic);
    this.itemQualityDatasource.data = this.itemgroup!.itemGroupCharacteristics;
    this.editedCharacteristic = itemgroupCharacteristic;
  }
}
